<template>
  <crud-data-table-form-dialog
    v-model="dialog"
    :loading="isLoading"
    :dialog-title="$t('dialogTitle')"
    :dialog-subtitle="$t('dialogSubtitle')"
    @onClose="onCloseDialog"
    @onSave="onSave"
  >
    <v-form
      ref="form"
      @submit.prevent
    >
      <title-field
        v-model="form.title"
        required
        autofocus
        :disabled="isLoading"
        @keypress.enter="onSave"
      />
    </v-form>
  </crud-data-table-form-dialog>
</template>

<script>
  import commonMessages from '../../commonMessages'
  import { showTheTitleHasAlreadyBeenTakenToast } from '@/services/api'

  export default {
    name: 'CreatePaymentRecurrenceDialog',
    data () {
      return {
        form: {
          title: '',
        },
        dialog: false,
        isLoading: false,
      }
    },
    methods: {
      closeDialogAndCleanForm () {
        this.dialog = false
        this.$refs.form.reset()
      },
      onSave () {
        if (this.$refs.form.validate()) {
          this.isLoading = true
          const { title } = this.form
          this.$store.dispatch('paymentRecurrences/createPaymentRecurrence', { title })
            .then(() => {
              this.closeDialogAndCleanForm()
              this.$store.dispatch('toast/setOptions', {
                variant: 'success',
                text: this.$t('createSuccess'),
              })
            })
            .catch(error => {
              const { status, data } = error.response
              if (status === this.$STATUS_CODE.UNPROCESSABLE_ENTITY) {
                const errorMessage = this.$t('paymentRecurrenceIsAlreadyRegisteredError', { title })
                showTheTitleHasAlreadyBeenTakenToast(data.errors.title[0], errorMessage)
              } else {
                this.$store.dispatch('toast/setOptions', {
                  variant: 'error',
                  text: this.$t('createError'),
                })
              }
            })
            .finally(() => {
              this.isLoading = false
            })
        }
      },
      onCloseDialog () {
        this.closeDialogAndCleanForm()
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          dialogTitle: 'Cadastro de recorrência',
          dialogSubtitle: 'Informe o título da nova recorrência.',
          createSuccess: 'Recorrência adicionada com sucesso!',
          createError: 'Ops... Algo deu errado ao tentar adicionar a recorrência. Por favor, tente novamente.',
        },
        'en-US': {
          dialogTitle: 'Payment recurrence registration',
          dialogSubtitle: 'Enter the title of the new payment recurrence.',
          createSuccess: 'Payment recurrence successfully added!',
          createError: 'Oops... Something went wrong while trying to add the payment recurrence. Please try again.',
        },
      },
      sharedMessages: commonMessages,
    },
  }
</script>
